#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <time.h>

//#define LIMIT 100

void main(int argc, char **argv)
{
	char myname[MPI_MAX_PROCESSOR_NAME];
	int size, rank, rlen;

	MPI_Init(&argc, &argv);
	MPI_Comm_size(MPI_COMM_WORLD, &size);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Get_processor_name(myname, &rlen);

	if (rank == 0) {//Process 0 PCmanager
		int x;
		//int cont = 0;
		while (true) {
			//printf("Cont %dn", cont);
			MPI_Recv(&x, 1, MPI_INT, 1, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
			MPI_Send(&x, 1, MPI_INT, 2, 0, MPI_COMM_WORLD);
		}
		//MPI_Abort(MPI_COMM_WORLD, 0);
	}
	else if (rank == 1) { //process 1 Producer
			int x;
		srand((int)time(NULL));
		while (true) {
			//printf("Sono %d ", rank);
			x = (int) rand() % 10;
			MPI_Send(&x, 1, MPI_INT, 0, 0, MPI_COMM_WORLD);
		}
	}
	else { //	process 2 Consumer
			int x;
		while (true) {
			MPI_Recv(&x, 1, MPI_INT, 0, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
			printf("Valore consumato di x %dn", x);
		}
	}

	MPI_Finalize();

}